
layui.define(['laytpl', 'element', 'layer', 'zlPinYin', 'common'], function (exports) {
	var $ = layui.jquery,
		element = layui.element,
		laytpl = layui.laytpl,
		zlPinYin = layui.zlPinYin,
		common = layui.common;
	var THEME = {
		defaulStyles: [
			{ name: '亮色风格', value: "light", color: '#f0f2f5' },
			{ name: '暗色风格', value: "dark", color: 'rgba(0,21,41,.85)' }
		],
		defaulColors: [
			{ name: "拂晓蓝", value: "#1890ff" },
			{ name: "薄暮", value: "#F5222D" },
			{ name: "火山", value: "#FA541C" },
			{ name: "日暮", value: "#FAAD14" },
			{ name: "明青", value: "#13C2C2" },
			{ name: "极光绿", value: "#52C41A" },
			{ name: "极客蓝", value: "#2F54EB" },
			{ name: "酱紫", value: "#60339a" },
		],
		defaulLayouts: [
			{ value: "left", name: '菜单在左边', icon: "url(" + layui.cache['contentPath'] + "/static/image/layout-left.svg)" },
			{ value: "top", name: '菜单在顶部', icon: "url(" + layui.cache['contentPath'] + "/static/image/layout-top.svg)" }
		],
		/**
		 * 默认主题
		 */
		getDefaulThemeObj() {
			var ColorBase = '#1890ff';
			return {
				'theme_title': "黑色主题",
				'theme_title-py': 'HeiSeZhuTi',
				style: 'light',
				color: ColorBase,
				layout: 'left',

				// logo
				logoFontColorInput: 'rgba(255,255,255,.8)', // logo字体颜色
				logoBgInput: '#20222A', // logo背景颜色

				// 导航栏
				navFont: "Microsoft YaHei", // 导航栏字体
				navBgInput: "#FFFFFF", // 导航栏背景
				navFontColorInput: "#333333", // 导航栏 字体颜色
				navIconColorInput: "#333333", // 导航栏 图标颜色
				// 菜单
				searchBoxBgInput: '#374850', // 搜索框背景
				searchBoxFontColorInput: '#FFFFFF', // 搜索框字体色
				menuBgInput: "#20222A", // 菜单背景
				childMenuBgInput: 'rgba(0, 0, 0, .3)',
				menuFont: "Microsoft YaHei", // 菜单字体
				menuFontColorInput: "#FFFFFF", // 菜单字体颜色
				menuSelectedBgInput: THEME.getLightColor(ColorBase, 0.5), // 菜单 选中项背景颜色
				menuSelectedFontColorInput: '#FFFFFF', // 菜单 选中项字体颜色
				menuItemBorderColorInput: '无', // 菜单 选中项字体颜色
				// 窗口
				layerTitleBgInput: "#F8F8F8", // 窗口标题背景
				layerCloseBtnColor: "1", // 窗口关闭按钮颜色
				layerTitleFontColorInput: "#333333", // 窗口标题字体颜色

				// 标准按钮
				btnBgInput: ColorBase, // 标准按钮背景
				btnFont: "Microsoft YaHei", // 标准按钮字体
				btnFontColorInput: "#FFFFFF", // 标准按钮字体颜色
				btnIconColorInput: "#FFFFFF", // 标准按钮图标颜色
				// 警告按钮
				dangerBtnBgInput: '#FF5722', // 警告按钮背景
				dangerBtnFont: 'Microsoft YaHei', // 警告按钮字体
				dangerBtnFontColorInput: "#FFFFFF", // 警告按钮字体颜色
				dangerBtnIconColorInput: "#FFFFFF", // 警告按钮图标颜色
				// 开关按钮
				switchBgInput: THEME.getLightColor(ColorBase, 0.5), // 开关按钮背景
				switchFont: "Microsoft YaHei", // 开关按钮字体
				switchFontColorInput: "#FFFFFF", // 开关按钮字体颜色
				// 复选框-默认
				checkBoxBgInput: THEME.getLightColor(ColorBase, 0.5), // 复选框-默认 背景
				checkBoxFontColorInput: "#FFFFFF", // 复选框-默认 字体颜色
				checkboxFont: "Microsoft YaHei", // 复选框-默认 字体
				// 复选框-原始
				originCheckBoxBgInput: THEME.getLightColor(ColorBase, 0.5), // 复选框-原始 背景
				originCheckBoxFontColorInput: "#FFFFFF", // 复选框-原始 字体颜色
				// 单选框
				radioBgInput: THEME.getLightColor(ColorBase, 0.5), // 单选框背景
				id: '25CE6A8B1C',
			}
		},
		/**
		 * 得到默认的主题数据
		 * @returns 返回主题数据对象
		 */
		getDefaultTheme() {
			return THEME.mergerExtendData(THEME.getDefaulThemeObj())
		},
		/**
		 * 融合额外的主题属性。一般是用于界面设计器
		 * @param {*} themeObj 主题数据对象
		 * @param {*} colorBase 基本颜色
		 */
		mergerExtendData(themeObj) {
			var ColorBase = themeObj.color || THEME.getDefaulThemeObj().color;
			if (!themeObj.kd_color_0) {
				return $.extend(themeObj, {
					/**
					 * 主色字体、边框的颜色调
					 */
					kd_color: THEME.getLightColor(ColorBase, 1),
					kd_color_0: THEME.getDarkColor(ColorBase, 0.1),
					kd_color_1: ColorBase,
					kd_color_2: THEME.getLightColor(ColorBase, 0.1),
					kd_color_3: THEME.getLightColor(ColorBase, 0.2),
					kd_color_4: THEME.getLightColor(ColorBase, 0.3),
					kd_color_5: THEME.getLightColor(ColorBase, 0.4),
					kd_color_6: THEME.getLightColor(ColorBase, 0.5),
					kd_color_7: THEME.getLightColor(ColorBase, 0.6),
					kd_color_8: THEME.getLightColor(ColorBase, 0.7),
					kd_color_9: THEME.getLightColor(ColorBase, 0.8),
					kd_color_10: THEME.getLightColor(ColorBase, 0.9),
					kd_color_11: THEME.getLightColor(ColorBase, 1),

					/**
					 * 连接的颜色
					 */
					kd_link_color: "#1e90ff",
					/**
					 * 设计焦点的颜色
					 */
					kd_design_focuse_color: "blue",

					/**
					 * 背景色
					 */
					kd_bg_color: ColorBase,
					/**
					 * 不可用的背景颜色
					 */
					kd_bg_color_disabled: "#C9C9C9",
					/**
					 *  激活（获取焦点）的背景颜色
					 */
					kd_bg_color_active: THEME.getLightColor(ColorBase, 0.1),

					/**
					 * 主色鼠标停留字体，边框的颜色
					 */
					kd_color_hover: THEME.getLightColor(ColorBase, 0.8),
					/**
					 * 主色激活（获取焦点）的颜色
					 */
					kd_color_active: THEME.getLightColor(ColorBase, 0.2),
					/**
					 * 主色不可用颜色
					 */
					kd_color_disabled: "#C2C2C2",
					/**
					 * 主色轮廓线颜色
					 */
					kd_color_outline: ColorBase,

					/**
					 * 主色组件边框颜色
					 */
					kd_border_color: "#C9C9C9",
					/**
					 * 主色组滚动框颜色
					 */
					kd_scroll_color: "#C9C9C9",

					/**
					 * 正常的字体颜色
					 * 一般是白底黑字/黑底白字
					 */
					kd_normal_font_color: "#555",

					/**
					 * 主色鼠标停留组件边框颜色
					 */
					kd_border_color_hover: THEME.getLightColor(ColorBase, 0.1),
					/**
					 * 主色激活（获取焦点）字体，边框的颜色
					 */
					kd_border_color_active: THEME.getLightColor(ColorBase, 0.7),
					/**
					 * 主色不可用边框颜色
					 */
					kd_border_color_disabled: "#C9C9C9",

					/**
					 * 成功主色调
					 */
					kd_success_color: "#52c41a",
					kd_success_color_hover: "#73d13d",
					kd_success_color_active: "#389e0d",
					kd_success_color_outline: "rgba(82,196,26,0.2)",

					/**
					 * 输入框的提示颜色
					 */
					kd_placeholder_color: "#b2b2b2",

					/**
					 *  错误的颜色
					 */
					kd_error_color: "#ff4d4f",
					kd_error_color_hover: "#ff7875",
					kd_error_color_active: "#d9363e",
					kd_error_color_outline: "rgba(255,77,79,0.2)",
					kd_error_color_bg: "#FF5722",
					kd_error_color_border: "#ffccc7",

					/**
					 *  警告颜色
					 */
					kd_warning_color: "#faad14",
					kd_warning_color_hover: "#ffc53d",
					kd_warning_color_active: "#d48806",
					kd_warning_color_outline: "rgba(250,173,20,0.2)",
					kd_warning_color_bg: "#FFB800",

					/**
					 * 信息提示颜色
					 */
					kd_info_color: ColorBase,
					kd_info_color_bg: "#e6f7ff",
					kd_info_color_border: "#91d5ff",


					// 标准按钮
					btnBgInput: ColorBase, // 标准按钮背景
					btnFont: "Microsoft YaHei", // 标准按钮字体
					btnFontColorInput: "#FFFFFF", // 标准按钮字体颜色
					btnIconColorInput: "#FFFFFF", // 标准按钮图标颜色
					// 警告按钮
					dangerBtnBgInput: '#FF5722', // 警告按钮背景
					dangerBtnFont: 'Microsoft YaHei', // 警告按钮字体
					dangerBtnFontColorInput: "#FFFFFF", // 警告按钮字体颜色
					dangerBtnIconColorInput: "#FFFFFF", // 警告按钮图标颜色
					// 开关按钮
					switchBgInput: THEME.getLightColor(ColorBase, 0.2), // 开关按钮背景
					switchFont: "Microsoft YaHei", // 开关按钮字体
					switchFontColorInput: "#FFFFFF", // 开关按钮字体颜色
					// 复选框-默认
					checkBoxBgInput: THEME.getLightColor(ColorBase, 0.2), // 复选框-默认 背景
					checkBoxFontColorInput: "#FFFFFF", // 复选框-默认 字体颜色
					checkboxFont: "Microsoft YaHei", // 复选框-默认 字体
					// 复选框-原始
					originCheckBoxBgInput: THEME.getLightColor(ColorBase, 0.2), // 复选框-原始 背景
					originCheckBoxFontColorInput: "#FFFFFF", // 复选框-原始 字体颜色
					// 单选框
					radioBgInput: THEME.getLightColor(ColorBase, 0.2), // 单选框背景
				})
			} else {
				return themeObj;
			}
		},
		/**
		 * 设置主题, 设置保存当前页面的主题,并创建css 的样式节点
		 * @param {*} theme 主题对象
		 * @param {*} isBroadcast 是否广播消息 
		 */
		setTheme: function (themeObj, isBroadcast = true) {
			sessionStorage.setItem('zltheme', JSON.stringify(themeObj))
			!!isBroadcast && common.broadcast('setTheme', JSON.stringify(themeObj));
		},
		/**
		 * 给当前的docoment增加主题的styleSheet
		 */
		renderCssStyle(themeObj) {
			if (themeObj && themeObj.childMenuBgInput && themeObj.childMenuBgInput.indexOf('.') != -1 && themeObj.childMenuBgInput.indexOf(',') != -1) {
				var arr = themeObj.childMenuBgInput.split(',');
				arr.pop();
				themeObj.childMenuTipsBgInput = arr.join() + ')';
			}
			themeObj.layerMinBtnColor = themeObj.layerCloseBtnColor == 1 ? "#2E2D3C" : "#fff";
			themeObj.layerMaxBtnColor = themeObj.layerCloseBtnColor == 1 ? "-32" : "-102";
			themeObj.layerMaxMinBtnColor = themeObj.layerCloseBtnColor == 1 ? "-65" : "-120";
			themeObj.menuItemBorderColorInput = themeObj.menuItemBorderColorInput == '无' ? 'none' : ('1px solid ' + themeObj.menuItemBorderColorInput);

			THEME.mergerExtendData(themeObj)


			var
				styleid = 'kd-theme-style',
				style = document.createElement('style'),
				styleElem = document.getElementById(styleid),
				styleText = laytpl(
					`
					:root{
						--kd-color: {{d.kd_color_3}} !important;
					}
					.layui-nav{
						background-color:{{d.navBgInput}};
					}
					.layui-layer .layui-layer-title,
						.layui-layer-iframe .layui-layer-title {
							background-color:{{d.layerTitleBgInput}} !important;
							color:{{d.layerTitleFontColorInput}};
						}
						.layui-layer-setwin .layui-layer-min cite {
							background-color:{{d.layerMinBtnColor}};
						}
						.layui-layer-setwin .layui-layer-max {
							background-position:{{d.layerMaxBtnColor}}px -40px;
						}
						.layui-layer-setwin .layui-layer-max.layui-layer-maxmin {
							background-position:{{d.layerMaxMinBtnColor}}px -40px;
						}
						.layui-layer-setwin .layui-layer-close1 {
							background-position:{{d.layerCloseBtnColor}}px -40px;
						}
						.layui-btn {
							background-color:{{d.btnBgInput}};
							color:{{d.btnFontColorInput}};
							font-family:{{d.btnFont}} !important;
						}
						.layui-btn i {
							color:{{d.btnIconColorInput}} !important;
						}
						.layui-btn.layui-btn-danger {
							background-color:{{d.dangerBtnBgInput}};
							color:{{d.dangerBtnFontColorInput}};
							font-family:{{d.dangerBtnFont}} !important;
						}
						.layui-btn.layui-btn-danger i {
							color:{{d.dangerBtnIconColorInput}} !important;
						}
						.layui-form-switch.layui-form-onswitch {
							border-color:{{d.switchBgInput}};
							background-color:{{d.switchBgInput}};
						}
						.layui-form-switch.layui-form-onswitch em {
							color:{{d.switchFontColorInput}} !important;
						}
						.layui-unselect.layui-form-switch em {
							font-family:{{d.switchFont}} !important;
						}
						.layui-form-switch.layui-form-onswitch i {
							background-color:{{d.switchFontColorInput}};
						}
						.layui-form-checkbox.layui-form-checked {
							border-color:{{d.checkBoxBgInput}};
						}
						.layui-unselect.layui-form-checkbox {
							font-family:{{d.checkboxFont}} !important;
						}
						.layui-form-checkbox.layui-form-checked span {
							background-color:{{d.checkBoxBgInput}};
							color:{{d.checkBoxFontColorInput}};
						}
						.layui-form-checkbox.layui-form-checked i {
							color:{{d.checkBoxBgInput}};
						}
						.layui-form-checkbox[lay-skin="primary"]:hover i {
							border-color: {{d.checkBoxBgInput}};
						  }
						.layui-form-checkbox.layui-form-checked[lay-skin="primary"] i {
							border-color:{{d.originCheckBoxBgInput}};
							background-color:{{d.originCheckBoxBgInput}};
							color:{{d.originCheckBoxFontColorInput}};
						}
						.layui-form-checkbox.layui-form-checked[lay-skin="primary"] span {
							color: #666;
							background: none !important;
						}
						.layui-form-radio.layui-form-radioed i {
							color:{{d.radioBgInput}};
						}
						.layui-form-radioed>i, .layui-form-radio>i:hover{
							color: {{d.radioBgInput}};
						}						
						.layui-form-select dl dd.layui-this {
							background-color:var(--kd-color);							
							color: {{d.kd_color_11}};
						}
						.kdayun-menu {
							font-family:{{d.menuFont}} !important;
							background-color:{{d.menuBgInput}}!important;
						}

						.kdayun-menu-item {
							font-family:{{d.menuFont}} !important;
							background-color:{{d.menuBgInput}}!important;
						}
						.kdayun-app-layout-top .kdayun-menu-container .kdayun-menu-ul .kdayun-menu-child {
							background-color:{{d.menuBgInput}}!important;
					   }
						.kdayun-app-layout-top .kdayun-menu-container .kdayun-menu-ul li:hover,
						.kdayun-app-layout-top .kdayun-menu-container .kdayun-menu-ul li li:hover>a:first-child:nth-last-child(2),
						.kdayun-app-layout-top .kdayun-menu-container .kdayun-menu-ul>li:hover>a:first-child:nth-last-child(2) {
							background-color: {{d.menuBgInput}}!important;
						}
						
						.navbar-side-search {
							background-color:{{d.menuBgInput}}!important;
						}
						.navbar-side-search input {
							background-color:{{d.searchBoxBgInput}}!important;
							border-color:{{d.searchBoxBgInput}}!important;
							color:{{d.searchBoxFontColorInput}}!important;
						}
						.navbar-side-search input:hover {
							border-color:{{d.searchBoxBgInput}}!important;
						}
						.navbar-side-search input:focus {
							border-color:{{d.searchBoxBgInput}}!important;
						}
						.navbar-side-search input::-webkit-input-placeholder {
							color:{{d.searchBoxFontColorInput}}!important;
						}
						.navbar-side-search input::-moz-placeholder {
							color:{{d.searchBoxFontColorInput}}!important;
						}
						.navbar-side-search input::-ms-input-placeholder {
							color:{{d.searchBoxFontColorInput}}!important;
						}
						.kdayun-menu-ul a,
						.kdayun-menu-ul i.layui-icon {
							color:{{d.menuFontColorInput}} !important;
						}
						.kdayun-menu-ul {
							border-top:{{d.menuItemBorderColorInput}};
						}
						.kdayun-menu-ul li.kdayun-menu-item {
							border-bottom:{{d.menuItemBorderColorInput}};
						}
						.kdayun-app-layout .kdayun-header .layui-nav-child dd.layui-this {
							background-color: `+ (themeObj.menuSelectedBgInput || themeObj.kd_color_5)  + `!important;
    						color: `+ (themeObj.menuSelectedFontColorInput || themeObj.kd_color_10)  + `!important;
						}
						.kdayun-app-layout .kdayun-header .layui-nav-child dd.layui-this a {
							background-color: `+ (themeObj.menuSelectedBgInput || themeObj.kd_color_5)  + `!important;
    						color: `+ (themeObj.menuSelectedFontColorInput || themeObj.kd_color_10)  + `!important;
						}
						.kdayun-menu-ul span.kdayun-menu-more {
							border-top-color:{{d.menuFontColorInput}} !important;
							border-bottom-color:{{d.menuBgInput}}00 !important;
						}
						.kdayun-menu-ul .kdayun-menu-item-expand>a span.kdayun-menu-more {
							border-top-color:{{d.menuBgInput}}00 !important;
							border-bottom-color:{{d.menuFontColorInput}} !important;
						}
						.kdayun-menu-item-expand>.kdayun-menu-child {
							background-color:{{d.childMenuBgInput}} !important;
						}
						.kdayun-menu-ul .layui-this a,
						.kdayun-menu-ul .layui-nav-bar {
							background-color:{{d.menuSelectedBgInput}} !important;
							color:{{d.menuSelectedFontColorInput||'var(--kd-color)'}} !important;
						}
						.layui-nav-bar{
							background-color: {{d.menuSelectedBgInput||'var(--kd-color)'}}!important;
						}
						.kdayun-app-layout .layui-header {
							font-family:{{d.navFont}} !important;
							background-color:{{d.navBgInput}};
						}
						.kdayun-app-layout .layui-header a:hover {
							color:{{d.navFontColorInput}};
						}
						.kdayun-app-layout .layui-header a cite {
							color:{{d.navFontColorInput}};
						}
						.kdayun-app-layout .layui-header a i.layui-icon,
						.kdayun-app-layout .layui-header a i.zlui-icon,
						.kdayun-app-layout .layui-header a i.fa {
							color:{{d.navIconColorInput}};
						}
						.kdayun-app-layout .layui-header a span.layui-nav-more {
							border-top-color:{{d.navIconColorInput}} !important;
							border-bottom-color:{{d.navBgInput}}00 !important;
						}
						.kdayun-app-layout .layui-header a span.layui-nav-mored { 
							border-top-color:{{d.navBgInput}}00 !important;
							border-bottom-color:{{d.navIconColorInput}} !important;
						}
						.kdayun-app-layout .layui-logo {
							background-color:{{d.logoBgInput}};
							color:{{d.logoFontColorInput}};
						}
						.layadmin-pagetabs .layui-tab-title li:after,
						.layadmin-pagetabs .layui-tab-title li.layui-this:after {
							background-color:{{d.menuSelectedBgInput||'var(--kd-color)'}};
						}
						.layui-tab-brief>.layui-tab-title .layui-this:after,
						.layui-tab-brief>.layui-tab-more li.layui-this:after {
							border-color:`+ themeObj.kd_color_1 + `;
						}
						.layui-table tbody tr:hover,.layui-table-hover,.layui-table-click{
							background-color:`+ (themeObj.kd_color_10 || '#f2f2f2') + `;
						}
						.layui-layer-tips.menuTips .layui-layer-content {
							background-color:`+ (themeObj.menuBgInput || THEME.colorReverse(themeObj.menuFontColorInput || "#000000")) + `;
							color:`+ (themeObj.menuFontColorInput || "#FFFFFF") + `;
						}
						.layui-layer-tips.menuTips .layui-layer-content i {
							border-bottom-color:`+ (themeObj.menuBgInput || THEME.getDarkColor(themeObj.menuFontColorInput || "#000000")) + `;
						}
						.layui-input:hover,
						.layui-textarea:hover,
						.layui-select:hover {
							border-color:`+ themeObj.kd_color_1 + `!important;
							outline: 0;
						}
						.layui-input:focus,
						.layui-textarea:focus,
						.layui-select:focus {
							border-color:`+ (themeObj.kd_color_1) + `!important;
							border-right-width: 1px!important;
							outline: 0;
							box-shadow : 0 0 0 2px `+ THEME.rgba(themeObj.kd_color_1, .2) + `;
						}
						.layui-card {
							box-shadow: 0 3px 1px -2px rgb(0 0 0 / 20%), 0 2px 2px 0 rgb(0 0 0 / 14%), 0 1px 5px 0 rgb(0 0 0 / 12%);
						}
						`).render(themeObj);

			if ('styleSheet' in style) {
				style.setAttribute('type', 'text/css');
				style.styleSheet.cssText = styleText;
			} else {
				style.innerHTML = styleText;
			}
			style.id = styleid;

			styleElem && $('body')[0].removeChild(styleElem);
			$('body')[0].appendChild(style);
			$('body').attr('layadmin-themealias', themeObj["theme_title-py"]);

			var iframes = $(".layadmin-iframe").contents();
			function setIframeTheme(iframes) {
				for (var i = 0; i < iframes.length; i++) {
					var $iframe = $(iframes[i]),
						$iframeBody = $(iframes[i]).find("body"),
						iframeBodyElemt = $iframeBody[0];
					var c_style = $iframe[0].createElement('style'),
						c_styleElem = $iframe[0].getElementById(styleid);
					if ('styleSheet' in c_style) {
						c_style.setAttribute('type', 'text/css');
						c_style.styleSheet.cssText = styleText;
					} else {
						c_style.innerHTML = styleText;
					}
					c_style.id = styleid;
					c_styleElem && iframeBodyElemt.removeChild(c_styleElem);
					iframeBodyElemt && iframeBodyElemt.appendChild(c_style);
					$iframeBody.attr('layadmin-themealias', themeObj["theme_title-py"]);
				}
			}
			$('body').addClass('loaded');
			$('#loader-wrapper .load_title').remove();
			setIframeTheme(iframes);
		},
		/**
		 * 获取当前的主题
		 * @param {*} isServer true 从服务端获取主题数据, false 先从本地获取主题数据，不存在再从服务端获取,服务器不存在就去。
		 */
		getTheme: function (isServer) {
			let ret = null;
			if (isServer) {
				ret = THEME.getCurrentThemeFromServer()
			} else {
				ret = sessionStorage.getItem('zltheme')
				if (!ret) {
					ret = THEME.getCurrentThemeFromServer()
				} else if (typeof (ret) == 'string') {
					ret = JSON.parse(ret)
				}
			}
			ret = ret || THEME.getDefaultTheme();
			return ret;
		},
		/**
		 * 得到机构的主题数组
		 * @param {*} orgid 机构id
		 * @param {*} callback(themeJson,err) 完成回调
		 */
		getThemes: function (orgid, callback) {
			let param = {
				orgid: orgid,
				optid: 'DF64BCDD33324F3DA4A63973E2462391'
			}
			$.ajax({
				url: layui.cache['contentPath'] + '/manager/coresysopt/queryxtypec',
				type: "GET",
				async: false,
				data: param,
				dataType: "json",
				contentType: "application/json",
				success: function (data) {
					if (data.state == 'OK') {
						callback && callback(JSON.parse(data.obj), null);
					} else {
						callback && callback(null, data.msg);
					}
				}
			});
		},
		/**
		 * 从后台服务端获取当前单位的主题 (同步方法)
		 * @param {*} callback(themeJson,err)  完成回调
		 * @returns 返回主题对象
		 */
		getCurrentThemeFromServer(callback) {
			let ret = null;
			$.ajax({
				url: layui.cache['contentPath'] + '/manager/coresysopt/querytheme',
				type: "POST",
				async: false,
				data: {},
				dataType: "json",
				contentType: "application/json",
				success: function (data) {
					if (data && data.state == 'OK' && data.obj) {
						ret = JSON.parse(data.obj);
						callback && callback(ret)
					} else {
						callback && callback(eval(null, data.msg))
					}
				}
			});
			return ret;
		},

		/**
		 * 16进制色值获取反色设置方法
		 * @param   strHex 为16进制色值的字符串（例：'#000000'）
		 * @return  返回反色的色值（例：'#ffffff'）
		 */
		colorReverse(strHex) {
			strHex = '0x' + strHex.replace(/#/g, '');
			let str = '000000' + (0xFFFFFF - strHex).toString(16);
			return '#' + str.substring(str.length - 6, str.length);
		},
		/**
		 * hex颜色转rgb颜色
		 * @param strHex 十六进制的颜色值格式（#ffc53d)
		 * @returns 返回RGB数组
		 */
		hexToRgb(strHex) {
			let r = /^\#?[0-9A-Fa-z]{6}$/;
			if (!r.test(strHex)) {
				common.msgError("输入错误的hex");
				return null;
			}
			strHex = strHex.replace("#", "");
			let hxs = strHex.match(/../g);
			for (let i = 0; i < 3; i++) {
				hxs[i] = parseInt(hxs[i], 16)
			};
			return hxs;
		},

		/**
		 * hex颜色转rgba颜色 ，这个是带有透明参数
		 * @param strHex 
		 * @param alpha 透明度 （0~1）之间浮点数
		 * @returns 返回 rgba(xx,xx,xx,0.2)格式的字符串
		 */
		rgba(strHex, alpha) {
			let rgb = THEME.hexToRgb(strHex);
			rgb.push(alpha);
			let ret = 'rgba(' + rgb.join(',') + ')'
			return ret;
		},

		/**
		 * GRB颜色转Hex颜色
		 * @param a  R 值
		 * @param b  G 值
		 * @param c  B 值
		 * @returns 返回十六进制字符串
		 */
		rgbToHex(a, b, c) {
			let r = /^\d{1,3}$/;
			if (!r.test(a) || !r.test(b) || !r.test(c)) {
				common.msgError("输入错误的rgb颜色值");
				return null;
			}
			let hexs = [a.toString(16), b.toString(16), c.toString(16)];
			for (let i = 0; i < 3; i++) if (hexs[i].length == 1) hexs[i] = "0" + hexs[i];
			return "#" + hexs.join("");
		},

		/**
		 * 得到hex颜色值为color的加深颜色值，level为加深的程度，限0-1之间
		 * @param color 颜色的16禁止字符串
		 * @param level 0-1 之间的浮点数
		 * @returns 返回十六进制字符串
		 */
		getDarkColor(color, level) {
			let r = /^\#?[0-9A-Fa-z]{6}$/;
			if (!r.test(color)) {
				common.msgError("输入错误的hex颜色值:" + color);
				return null;
			}
			let rgbc = THEME.hexToRgb(color);
			//floor 向下取整
			for (let i = 0; i < 3; i++) rgbc[i] = Math.floor(rgbc[i] * (1 - level));
			return THEME.rgbToHex(rgbc[0], rgbc[1], rgbc[2]);
		},

		/**
		 * 得到hex颜色值为color的减淡颜色值，level为加深的程度，限0-1之间
		 * @param color 颜色的16禁止字符串
		 * @param level 0-1 之间的浮点数
		 * @returns 返回十六进制字符串
		 */
		getLightColor(color, level) {
			let r = /^\#?[0-9A-Fa-z]{6}$/;
			if (!r.test(color)) {
				common.msgError("输入错误的hex颜色值:" + color); return;
			}
			let rgbc = THEME.hexToRgb(color);
			for (let i = 0; i < 3; i++) rgbc[i] = Math.floor((255 - rgbc[i]) * level + rgbc[i]);
			let ret = THEME.rgbToHex(rgbc[0], rgbc[1], rgbc[2]);
			return ret;
		},

		/**
		 * 开始渲染主题
		 */
		render(isServer, isDefalut) {
			var themeObj = THEME.getTheme(isServer);
			if (isDefalut) {
				var leftThemeRender = new LeftTheme(themeObj);
				leftThemeRender.render();
				return;
			}

			if (themeObj.layout == 'top') {
				var topThemeRender = new TopTheme(themeObj);
				topThemeRender.render();
			} else {
				var leftThemeRender = new LeftTheme(themeObj);
				leftThemeRender.render();
			}
		}
	}
	window['SVGInject'] && window['SVGInject'].setOptions({
		afterLoad: function (svg, svgString) {
			svgString = svgString.replace(/fill="#([0-9a-fA-F]{6}|[0-9a-fA-F]{3})"/g, '')
			svg.classList.add('my-class');
			return svgString
		},
	});
	/**
	 * 主题渲染类
	 * @param {*} config 
	 */
	var ThemeRenderBase = function (config) {
		this.config = {
			$elem: $('#kdayun-app'), //主容器
			$headerElem: $('.layui-header'),
			$tabElem: $('.layadmin-pagetabs'),
			$menuElem: $('.kdayun-menu'),
			$logoElem: $('.layui-logo'),
			theme: THEME.getTheme(), //主题
		}
	}
	ThemeRenderBase.prototype.constructor = ThemeRenderBase;
	ThemeRenderBase.prototype.render = function () {
		var that = this;
		that.config.$elem.empty();
		that.renderHeader();
		that.renderMenus();
		that.renderBody();
		that.renderFoot();
	};
	ThemeRenderBase.prototype.renderHeader = function () {
		var that = this;
		that.config.$headerElem = $($('#tpl-header').html());
		that.config.$elem.append(that.config.$headerElem);
		that.config.$headerElem.append($('#tpl-header-left-tools').html());
		that.config.$headerElem.append($('#tpl-header-right-tools').html())
	};
	ThemeRenderBase.prototype.renderMenus = function () {
		var that = this;
		that.config.$menuElem = $($('#tpl-left-side').html())
		that.config.$elem.append(that.config.$menuElem);
		that.config.$menuElem.append($('#tpl-search').html())
		that.config.$menuElem.find('.navbar-side-search').before($('#tpl-logo').html())
		that.config.$menuElem.find('.navbar-side-search').after($('#tpl-menu').html())
		var menuRender = new LeftMenuRender()
		menuRender.set({
			spreadOne: true,
			elem: '#admin-navbar-menu',
			cached: false,
			url: layui.cache['contentPath'] + '/core/security/querymenuauth',
			type: 'post'
		});
		menuRender.render();
	};
	ThemeRenderBase.prototype.renderFoot = function () {
		var that = this;
	};
	ThemeRenderBase.prototype.renderBody = function () {
		var that = this;
		that.config.$menuElem = $($('#tpl-body').html())
		that.config.$elem.append(that.config.$menuElem);
	};




	/**
	 * 菜单靠左的布局
	 */
	var LeftTheme = function (config) {
		ThemeRenderBase.call(this, config);
	};
	(function () {
		var Super = function () { };
		Super.prototype = ThemeRenderBase.prototype;
		LeftTheme.prototype = new Super();
	})();
	LeftTheme.prototype.constructor = LeftTheme;
	LeftTheme.prototype.render = function () {
		var that = this;
		this.config.$elem.removeClass('kdayun-app-layout-top').addClass('kdayun-app-layout-left')
		ThemeRenderBase.prototype.render.call(this)

	}
	/**
	 * 菜单是在头部
	 */
	var TopTheme = function (config) {
		ThemeRenderBase.call(this, config);
	};
	(function () {
		var Super = function () { };
		Super.prototype = ThemeRenderBase.prototype;
		TopTheme.prototype = new Super();
	})();
	TopTheme.prototype.constructor = TopTheme;
	TopTheme.prototype.render = function () {
		var that = this;
		this.config.$elem.removeClass('kdayun-app-layout-left').addClass('kdayun-app-layout-top')
		ThemeRenderBase.prototype.render.call(this)
		this.config.$elem.find('a').removeAttr('lay-tips')

	}
	TopTheme.prototype.renderMenus = function () {
		var that = this;
		that.config.$headerElem.find('.layui-layout-left').remove();
		that.config.$headerElem.append($('#tpl-logo').html());
		that.config.$headerElem.append($('#tpl-menu').html());
		that.config.$menuElem = $('#admin-navbar-menu')
		// that.config.$menuElem.after($('#tpl-search').html())
		var menuRender = new TopMenuRender();
		menuRender.set({
			spreadOne: true,
			elem: '#admin-navbar-menu',
			cached: false,
			url: layui.cache['contentPath'] + '/core/security/querymenuauth',
			type: 'post'
		});
		menuRender.render();
	};

	var MenuRenderBase = function (config) {
		/**
		 *  默认配置 
		 */
		this.config = {
			elem: undefined, //容器
			data: undefined, //数据源
			url: undefined, //数据源地址
			type: 'GET', //读取方式
			cached: false, //是否使用缓存
			spreadOne: false //设置是否只展开一个二级菜单
		}
	};
	/**
	 * 渲染菜单
	 */
	MenuRenderBase.prototype.render = function () {
		var that = this;
		var _config = that.config;
		if (typeof (_config.elem) !== 'string' && typeof (_config.elem) !== 'object') {
			common.throwError('MenuRender error: elem参数未定义或设置出错，具体设置格式请参考文档API.');
		}
		var $container;
		if (typeof (_config.elem) === 'string') {
			$container = $('' + _config.elem + '');
		}
		if (typeof (_config.elem) === 'object') {
			$container = _config.elem;
		}
		if ($container.length === 0) {
			common.throwError('MenuRender error:找不到elem参数配置的容器，请检查.');
		}
		if (_config.data === undefined && _config.url === undefined) {
			common.throwError('MenuRender error:请为Navbar配置数据源.')
		}
		if (_config.data !== undefined && typeof (_config.data) === 'object') {
			var html = that.getHtml(_config.data);
			$container.html(html);
			that.iniEvent();
			element.init();
			that.config.elem = $container;
		} else {
			$.ajax({
				type: _config.type,
				url: _config.url,
				async: false, //_config.async,
				dataType: 'json',
				success: function (result, status, xhr) {
					var html = that.getHtml(result.obj);
					$container.html(html);
					element.init();
				},
				error: function (xhr, status, error) {
					common.msgError('MenuRender error:' + error);
				},
				complete: function (xhr, status) {
					that.config.elem = $container;
				}
			});
		}

		//只展开一个二级菜单
		if (_config.spreadOne) {
			var $ul = $container.children('ul');
			$ul.find('li.kdayun-menu-item').each(function () {
			});
		}

		this.iniEvent();
		return that;
	};
	MenuRenderBase.prototype.iniEvent = function () {
		this.iniMenuClickEvent();
		this.iniSearchEvent();
	};
	MenuRenderBase.prototype.iniMenuClickEvent = function () {
		var that = this;
		that.config.elem.on('click', "a", function (e) {
			var othis = $(this)
				, parents = othis.parents('.kdayun-menu-ul')
				, filter = parents.attr('lay-filter')
				, parent = othis.parent()
				, child = othis.siblings('.kdayun-menu-child');

			var shrinkParents = othis.parents('.layadmin-side-shrink');
			if (shrinkParents.length > 0) {
				shrinkParents.removeClass('layadmin-side-shrink')
			}

			//如果是垂直菜单
			if (child[0]) {
				parent[child.css('display') === 'none' ? 'addClass' : 'removeClass']('kdayun-menu-item-expand');
				if (parents.attr('lay-shrink') === 'all') {
					parent.siblings().removeClass('kdayun-menu-item-expand');
				}
			}
			href = othis.attr('yh-href'),
				text = othis.attr('lay-text'),
				resid = othis.attr('resid'),
				searchBox = othis.parents('div#admin-navbar-menu').siblings('div.navbar-side-search');
			searchBox.find('ul.navbarSearchResult ').removeClass('layui-show').addClass('layui-hide');
			searchBox.find('input#navbarSearchValue').val('');
			common.tabsPage.elem = othis;
			if (!common.isEmpty(href)) {
				common.openTabsPage(href, text || othis.text(), resid);
				parent.addClass('layui-this');
			}
			common.sendTo(filter, 'MENU_CLICK', othis)
			e.stopPropagation();
		})
	}
	MenuRenderBase.prototype.iniSearchEvent = function () {
		$('#navbarSearchValue').on('keyup', function (e) {
			navbarSeacherHandle($(this).val(), this)
		});
		$('#navbarSearchIcon').on('click', function () {
			navbarSeacherHandle($(this).siblings('input').val(), this)
		});
		// 点击搜索项 
		$('ul.navbarSearchResult').on('click', 'li', function () {
			var value = $(this).find('cite').html();
			$('ul.navbarSearchResult').removeClass('layui-show').addClass('layui-hide');
			$(this).parent().siblings('input').val('');
			if (!$('#admin-navbar-menu').find('a[lay-tips="' + value + '"]').parent().hasClass('kdayun-menu-item-expand')) {
				$('#admin-navbar-menu').find('a[lay-tips="' + value + '"]').click();
			}
		})

		function navbarSeacherHandle(value, dom) {
			var targetData = $(dom).parent('div.navbar-side-search').siblings('div#admin-navbar-menu').find('a'),
				ulItem = $(dom).siblings('ul.navbarSearchResult'),
				num = 0;
			ulItem.html(' ');
			if (value == '') {
				ulItem.addClass('layui-hide').removeClass('layui-show');
				return;
			}
			for (var i = 0; i < targetData.length; i++) {
				var matchingTarget = $(targetData[i]).find('cite').html(),
					imgHtml = $(targetData[i]).find('img').length > 0 ? $(targetData[i]).find('img')[0].outerHTML : '<i class="fa fa-file"></i>';

				if (matchingTarget.indexOf(value) != -1 || zlPinYin.A(matchingTarget).toLowerCase().indexOf(value.toLowerCase()) != -1) {
					ulItem.append('<li class="search-result-item">' + imgHtml + '<cite>' + matchingTarget + '</cite></li>');
					num++;
				}
			}
			ulItem.removeClass('layui-hide').addClass('layui-show');
			if (num == 0) {
				ulItem.append('<li>未查询到对应数据！</li>')
			}
		}
	};
	/**
	 * 获取html字符串
	 * @param {Object} data 菜单的项数组
	 */
	MenuRenderBase.prototype.getHtml = function (data) {
		var ulHtml = '<ul class="kdayun-menu-ul" lay-shrink="all" id="LAY-system-side-menu" lay-filter="layadmin-system-side-menu">';
		for (var i = 0; i < data.length; i++) {
			if (data[i].spread) {
				ulHtml += '<li class="kdayun-menu-item kdayun-menu-item-expand">';
			} else {
				ulHtml += '<li class="kdayun-menu-item">';
			}
			ulHtml += this.getItemHtml(data[i]);

			ulHtml += '</li>';
		}
		ulHtml += '</ul>';

		return ulHtml;
	};
	MenuRenderBase.prototype.getTokenIdUrl = function (url, resid) {
		if (url.indexOf("?") != -1) {
			return '&tokenId=' + ($('#tokenId').val() ? $('#tokenId').val() : '') + '&resId=' + resid;
		} else {
			return '?tokenId=' + ($('#tokenId').val() ? $('#tokenId').val() : '') + '&resId=' + resid;
		}
	};
	/**
	 * 获取一个菜单的的html
	 * @param {*} item 
	 */
	MenuRenderBase.prototype.getItemHtml = function (item) {
		var ulHtml = '';
		var url = item.href;
		if (url != null) {
			url = url.replace(/#{contentpath}/i, layui.cache['contentPath']);
		}
		var iconUrl = layui.cache['contentPath'] + item.icon;
		var svgOnLoad = ''
		if (iconUrl && (iconUrl.indexOf('.svg') != -1 || iconUrl.indexOf('.SVG') != -1)) {
			svgOnLoad = 'onload = "SVGInject(this)" fill="currentColor"'
		}

		var layhref = (url !== undefined && url !== '' && url !== null) ? 'yh-href="' + url + '"' : '';
		ulHtml += '<a href="javascript:;" ' + layhref + ' lay-text="' + item.title + '" lay-tips="' + item.title + '" lay-direction="2" resId=' + item.resid + ' >';
		if (item.icon != undefined && item.icon != '') {
			ulHtml += '<img src="' + layui.cache['contentPath'] + item.icon + '" ' + svgOnLoad + ' style="width:16px;height:16px;vertical-align: text-bottom;">';
		}
		if (item.children != undefined && item.children != undefined && item.children.length > 0) {
			ulHtml += '<cite>' + item.title + '</cite>'
			ulHtml += '<span class="kdayun-menu-more"></span>'
			ulHtml += '</a>';
			ulHtml += '<ul class="kdayun-menu-child">'
			for (var j = 0; j < item.children.length; j++) {
				ulHtml += '<li>';
				if (item.children !== undefined && item.children.length > 0)
					ulHtml += this.getItemHtml(item.children[j]);
				ulHtml += '</li>';
			}
			ulHtml += '</ul>';
		} else {
			ulHtml += '<cite>' + item.title + '</cite>'
			ulHtml += '</a>';
		}
		return ulHtml;
	}
	/**
	 * 配置MenuRender
	 * @param {Object} options
	 */
	MenuRenderBase.prototype.set = function (options) {
		var that = this;
		that.config.data = undefined;
		$.extend(true, that.config, options);
		return that;
	};
	/**
	 * 绑定事件
	 * @param {String} events
	 * @param {Function} callback
	 */
	MenuRenderBase.prototype.on = function (events, callback) {
		var that = this;
		var _con = that.config.elem;
		if (typeof (events) !== 'string') {
			common.throwError('MenuRender error:事件名配置出错，请参考API文档.');
		}
		var lIndex = events.indexOf('(');
		var eventName = events.substr(0, lIndex);
		var filter = events.substring(lIndex + 1, events.indexOf(')'));
		if (eventName === 'click') {
			if (_con.attr('lay-filter') !== undefined) {
				_con.children('ul').find('li').each(function () {
					var $this = $(this);
					if ($this.find('ul').length > 0) {
						var $li = $this.find('li').each(function () {
							$(this).on('click', function () {
								var $a = $(this).children('a');
								var href = $a.data('url');
								var icon = $a.children('i:first').data('icon');
								var title = $a.children('cite').text();
								if (href) {
									var data = {
										elem: $a,
										field: {
											href: href,
											icon: icon,
											title: title
										}
									}
									callback(data);
								}
							});
						});
					} else {
						$this.on('click', function () {
							var $a = $this.children('a');
							var href = $a.data('url');
							var icon = $a.children('i:first').data('icon');
							var title = $a.children('cite').text();
							if (href) {
								var data = {
									elem: $a,
									field: {
										href: href,
										icon: icon,
										title: title
									}
								}
								callback(data);
							}
						});
					}
				});
			}
		}
	};
	/**
	 * 清除缓存
	 */
	MenuRenderBase.prototype.cleanCached = function () {
	};


	var TopMenuRender = function () {
		MenuRenderBase.call(this);
	};
	(function () {
		var Super = function () { };
		Super.prototype = MenuRenderBase.prototype;
		TopMenuRender.prototype = new Super();
	})();
	/**
	 * 渲染菜单
	 */
	TopMenuRender.prototype.render = function () {
		MenuRenderBase.prototype.render.call(this);
		this.config.elem.find('.kdayun-menu-more').remove();
	};

	/**
	 * 菜单的渲染器
	 */
	var LeftMenuRender = function () {
		MenuRenderBase.call(this);

	};
	(function () {
		var Super = function () { };
		Super.prototype = MenuRenderBase.prototype;
		LeftMenuRender.prototype = new Super();
	})();


	!function () {
		common.on('setTheme', function (event) {
			var themeObj = JSON.parse(event.params);
			if (themeObj) {
				THEME.renderCssStyle(themeObj);
			}
			// $('.kdayun-layout-body').length > 0 && THEME.render(false, false)
			element.render();
		})
		//当前设定主题设置 并排除掉平台主框架页面它在admin.js内加载
		if (!window['--hasload-kd-Theme'] && $('.kdayun-layout-body').length == 0) {
			let m = THEME.getTheme(false);
			if (m) {
				THEME.setTheme(m, false);
				THEME.renderCssStyle(m);
				common.broadcast('TabPageFinished', {});
			}
		}
		$('body').addClass('loaded');
		$('#loader-wrapper .load_title').remove();
	}();

	//对外接口
	exports('theme', THEME);
	window['kdtheme'] = THEME;
});