layui.define(['zlContext', 'layer', 'laytpl', 'colorpicker', 'zlPinYin', 'theme'], function (exports) {
    var $ = layui.$,
        zlContext = layui.zlContext,
        layer = layui.layer,
        colorpicker = layui.colorpicker,
        laytpl = layui.laytpl,
        zlPinYin = layui.zlPinYin,
        form = layui.form,
        theme = layui.theme;
    var zlTheme = {
        ZL_theme: null,
        temporary_theme: null,

        /**
         * 吧主体填充到form内的组件
         * @param {*} themeData 
         */
        formFillData: function (themeData) {
            form.val("theme-form", {
                theme_title: themeData.theme_title, // 主题名称
                logoFontColorInput: themeData.logoFontColorInput, // logo字体颜色
                logoBgInput: themeData.logoBgInput, // logo背景颜色
                navFont: themeData.navFont, // 导航栏字体
                navBgInput: themeData.navBgInput, // 导航栏背景
                navFontColorInput: themeData.navFontColorInput, // 导航栏 字体颜色
                navIconColorInput: themeData.navIconColorInput, // 导航栏 图标颜色
                searchBoxBgInput: themeData.searchBoxBgInput, // 搜索框背景
                searchBoxFontColorInput: themeData.searchBoxFontColorInput, // 搜索框字体色
                menuBgInput: themeData.menuBgInput, // 菜单背景
                childMenuBgInput: themeData.childMenuBgInput, // 左侧子级菜单背景
                menuFont: themeData.menuFont, // 菜单字体
                menuFontColorInput: themeData.menuFontColorInput, // 菜单字体颜色
                menuSelectedBgInput: themeData.menuSelectedBgInput, // 菜单 选中项背景颜色
                menuSelectedFontColorInput: themeData.menuSelectedFontColorInput, // 菜单 选中项字体颜色
                menuItemBorderColorInput: themeData.menuItemBorderColorInput, // 菜单 菜单项边框
                
                btnBgInput: themeData.btnBgInput, // 标准按钮背景
                btnFont: themeData.btnFont, // 标准按钮字体
                btnFontColorInput: themeData.btnFontColorInput, // 标准按钮字体颜色
                btnIconColorInput: themeData.btnIconColorInput, // 标准按钮图标颜色
                dangerBtnBgInput: themeData.dangerBtnBgInput, // 警告按钮背景
                dangerBtnFont: themeData.dangerBtnFont, // 警告按钮字体
                dangerBtnFontColorInput: themeData.dangerBtnFontColorInput, // 警告按钮字体颜色
                dangerBtnIconColorInput: themeData.dangerBtnIconColorInput, // 警告按钮图标颜色
                switchBgInput: themeData.switchBgInput, // 开关按钮背景
                switchFont: themeData.switchFont, // 开关按钮字体
                switchFontColorInput: themeData.switchFontColorInput, // 开关按钮字体颜色
                checkBoxBgInput: themeData.checkBoxBgInput, // 复选框-默认 背景
                checkBoxFontColorInput: themeData.checkBoxFontColorInput, // 复选框-默认 字体颜色
                checkboxFont: themeData.checkboxFont, // 复选框-默认 字体
                originCheckBoxBgInput: themeData.originCheckBoxBgInput, // 复选框-原始 背景
                originCheckBoxFontColorInput: themeData.originCheckBoxFontColorInput, // 复选框-原始 字体颜色
                radioBgInput: themeData.radioBgInput, // 单选框背景
                layerTitleBgInput: themeData.layerTitleBgInput, // 窗口标题背景
                layerCloseBtnColor: themeData.layerCloseBtnColor, // 窗口关闭按钮颜色
                layerTitleFontColorInput: themeData.layerTitleFontColorInput, // 窗口标题字体颜色
            })
        },
        renderThemeList(layero, themes, v) {
            var getTpl = theme_setter_template.innerHTML,
                view = document.getElementById('theme-setter');
            laytpl(getTpl).render(themes, function (html) {
                view.innerHTML = html;
            });
            if (!themes) return;
            // 获取当前选中主题
            for (var i = 0; i < themes.length; i++) {
                if (themes[i].id == v) {
                    zlTheme.ZL_theme = themes[i];
                }
            }
            layero.find('li[data-tid="' + zlTheme.ZL_theme.id + '"]').addClass('layui-this');
        },
        renderColor(themeData) {
            var $ul = $('.layui-form-item.color ul')
            $ul.empty();
            if (!themeData.colors) { themeData.colors = theme.defaulColors; }
            $ul.append('<input name="color"/>');
            for (let i = 0; i < themeData.colors.length; i++) {
                const color = themeData.colors[i];
                var $li = $('<li data-value="' + color.value + '"  title="' + color.name + '"></li>')
                $ul.append($li)
                $li.css({ "background-color": color.value })
                if (themeData.color == color.value) {
                    $li.addClass('theme-color-active').addClass('fa fa-check')
                    $li.attr('checked', true)
                    $ul.find('input').val(color.value);
                }
            }

        },
        renderStyle(themeData) {
            var $ul = $('.layui-form-item.style ul')
            $ul.empty();
            if (!themeData.styles) { themeData.styles = theme.defaulStyles; }
            $ul.append('<input  name="style"/>');
            for (let i = 0; i < themeData.styles.length; i++) {
                const style = themeData.styles[i];
                var $li = $('<li data-value="' + style.value + '" title="' + style.name + '"></li>')
                $ul.append($li)
                $li.css({ "background-color": style.color })
                if (themeData.style == style.value) {
                    $li.addClass('theme-style-active').addClass('fa fa-check')
                    $li.attr('checked', true)
                    $ul.find('input').val(style.value);
                }
            }
        },
        renderLayout(themeData) {
            var $ul = $('.layui-form-item.layout ul')
            $ul.empty();
            if (!themeData.layouts) { themeData.layouts = theme.defaulLayouts }
            $ul.append('<input name="layout"/>');
            for (let i = 0; i < themeData.layouts.length; i++) {
                const layout = themeData.layouts[i];
                var $li = $('<li data-value="' + layout.value + '"  title="' + layout.name + '"></li>')
                $li.css({ "background-image": layout.icon })
                $ul.append($li)
                if (themeData.layout == layout.value) {
                    $li.addClass('theme-style-active').addClass('fa fa-check')
                    $ul.find('input').val(layout.value);
                    $li.attr('checked', true)
                }
            }
        },
        renderThemeBody(layero) {
            // 渲染选中主题内容到右侧form表单中

            zlTheme.formFillData(zlTheme.ZL_theme);
            if (zlTheme.ZL_theme.id === '25CE6A8B1C') {
                layero.find('input').prop('disabled', true);
                layero.find('select').prop('disabled', true);
                layero.find('.showFlag').find('input').prop('disabled', false);
                layero.find('input[type="file"]').prop('disabled', false);
                layero.find('.operationBtn').hide();
            } else {
                layero.find('input').attr("readOnly", "true");
                layero.find('.showFlag').find('input').prop('readOnly', false);
            }

            // 颜色输入框关联到颜色选择器
            layero.find('input').change(function () {
                if ($(this).attr('id')) {
                    colorpicker.render({
                        elem: '#' + $(this).attr('id').replace(/Input/ig, ''),
                        color: $(this).val(),
                        format: 'rgb',
                        alpha: true
                    });
                }
            })

            zlTheme.renderColor(zlTheme.ZL_theme);
            zlTheme.renderStyle(zlTheme.ZL_theme);
            zlTheme.renderLayout(zlTheme.ZL_theme);

            zlTheme.renderColorPicker(layero);
            // form.render(null, 'theme-form');
            zlTheme.renderOptionsFontFamily(layero);

            form.on('select', function (data) {
                $(data.othis).find('input').css('font-family', data.value);
                layero.find('button[lay-filter="themeForm"]').addClass('revised');
            });

            layero.on('blur', 'input[name="theme_title"]', function () {
                if ($(this).val() != zlTheme.ZL_theme.theme_title && !layero.find('li.layui-this').hasClass('newTheme')) {
                    layero.find('button[lay-filter="themeForm"]').addClass('revised');
                }
            })
            zlTheme.renderThemeEffect(layero, zlTheme.ZL_theme);

        },
        renderOptionsFontFamily(layero) {
            var select_items = layero.find('select');
            for (var i = 0; i < select_items.length; i++) {
                var dd_items = $(select_items[i]).siblings('.layui-form-select').find('dd'),
                    input_item = $(select_items[i]).siblings('.layui-form-select').find('input');
                input_item.css('font-family', input_item.val())
                for (var k = 0; k < dd_items.length; k++) {
                    if ($(dd_items[k]).attr('lay-value')) {
                        $(dd_items[k]).css('font-family', $(dd_items[k]).attr('lay-value'))
                    }
                }
            }
        },
        renderColorPicker(layero) {
            var colorRenderItems = layero.find('.colorpickerElem')
            for (var index = 0; index < colorRenderItems.length; index++) {
                var element = colorRenderItems[index],
                    inputVal = $('#' + $(element).attr('id') + 'Input').val();
                colorpicker.render({
                    elem: '#' + $(element).attr('id'),
                    color: inputVal,
                    alpha: true,
                    format: 'rgb',
                    done: function (color) {
                        if (layero.find('li.layui-this').attr('data-tid') == '25CE6A8B1C') {
                            zlContext.warnMsg('系统自带主题禁止修改！');
                            return false;
                        }
                        var inputVal = color != '' ? (color.indexOf('#') != -1 ? color.toLocaleUpperCase() : zlTheme.color2Hex(color).toLocaleUpperCase()) : (this.elem == "#menuItemBorderColor" ? '无' : '');

                        $(this.elem + 'Input').val(inputVal);
                        layero.find('button[lay-filter="themeForm"]').addClass('revised');
                    }
                });
            }
        },
        /**
         * 渲染标准组件的效果
         **/
        renderThemeEffect(layero, themeData) {
            layero.find('.standardButton').css({
                'background-color': themeData.btnBgInput ? themeData.btnBgInput : 'rgb(39, 127, 208)',
                'font-family': themeData.btnFont + '!important',
                'color': themeData.btnFontColorInput ? themeData.btnFontColorInput : 'rgb(255, 255, 255)'
            }).find('i').css('color', themeData.btnIconColorInput ? themeData.btnIconColorInput : 'rgb(255, 255, 255)');

            layero.find('.dangerButton').css({
                'background-color': themeData.dangerBtnBgInput ? themeData.dangerBtnBgInput : '#FF5722',
                'font-family': themeData.dangerBtnFont + '!important',
                'color': themeData.dangerBtnFontColorInput ? themeData.dangerBtnFontColorInput : 'rgb(255, 255, 255)'
            }).find('i').css('color', themeData.dangerBtnIconColorInput ? themeData.dangerBtnIconColorInput : 'rgb(255, 255, 255)');

            layero.find('.switchButton .layui-form-switch').css({
                'border-color': themeData.switchBgInput ? themeData.switchBgInput : 'rgb(95, 184, 120)',
                'background-color': themeData.switchBgInput ? themeData.switchBgInput : 'rgb(95, 184, 120)'
            }).find('em').css({
                'font-family': themeData.switchFont + '!important',
                'color': themeData.switchFontColorInput ? themeData.switchFontColorInput + '!important' : 'rgb(255, 255, 255) !important'
            });

            layero.find('.defaultCheckBox').css('border-color', themeData.checkBoxBgInput ? themeData.checkBoxBgInput : 'rgb(95, 184, 120)')
                .find('span').css({
                    'background-color': themeData.checkBoxBgInput ? themeData.checkBoxBgInput : 'rgb(95, 184, 120)',
                    'color': themeData.checkBoxFontColorInput ? themeData.checkBoxFontColorInput : 'rgb(255, 255, 255)',
                    'font-family': themeData.checkboxFont + '!important'
                }).siblings('i').css('color', themeData.checkBoxBgInput ? themeData.checkBoxBgInput : 'rgb(95, 184, 120)');

            layero.find('.originCheckBox i').css({
                'border-color': themeData.originCheckBoxBgInput ? themeData.originCheckBoxBgInput : 'rgb(95, 184, 120)',
                'background-color': themeData.originCheckBoxBgInput ? themeData.originCheckBoxBgInput : 'rgb(95, 184, 120)',
                'color': themeData.originCheckBoxFontColorInput ? themeData.originCheckBoxFontColorInput : 'rgb(255, 255, 255)'
            });
        },
        /**
         * 初始化按钮事件
         */
        initEvent(layero, themes, currNodeRwid, optid) {
            // 新增主题
            function addTheme(layero, that) {
                var id = zlContext.generateId().toLocaleUpperCase();
                var Existing_themes_num = parseInt(layero.find('ul.layadmin-setTheme-color').find('li').length) + 1,
                    theme_title_py = zlPinYin.A('新增主题-' + Existing_themes_num),
                    addHtml = [
                        '<li data-tid="' + id + '" data-alias="' + theme_title_py + '" class="layui-this newTheme"> ',
                        '    <div class="theme-name">新增主题-' + Existing_themes_num + '</div> ',
                        '    <div class="blank"></div> ',
                        '    <div class="layadmin-setTheme-header" style="background-color: #f5f5f5;"></div> ',
                        '    <div class="layadmin-setTheme-side" style="background-color: #20222A;"> ',
                        '        <div class="layadmin-setTheme-logo" style="background-color: #20222A;"></div> ',
                        '    </div> ',
                        '</li>'
                    ];
                layero.find('li.layui-this').removeClass('layui-this');
                zlTheme.formFillData(theme.getDefaultTheme());
                form.val("theme-form", {
                    'theme_title': '新增主题-' + Existing_themes_num
                });

                layero.find('input').prop({
                    'readOnly': true,
                    'disabled': false
                });
                layero.find('input[name="theme_title"]').prop({
                    'readOnly': false,
                    'disabled': false
                });
                layero.find('select').prop('disabled', false);
                layero.find('.operationBtn').show();

                zlTheme.renderColor(zlTheme.ZL_theme);
                zlTheme.renderStyle(zlTheme.ZL_theme);
                zlTheme.renderLayout(zlTheme.ZL_theme);

                zlTheme.renderColorPicker(layero);
                zlTheme.renderOptionsFontFamily(layero);
                layero.find('ul.layadmin-setTheme-color').append(addHtml.join(' '))
            }
            layero.on('click', '#addTheme', function () {
                if (layero.find('li.newTheme').length > 0) {
                    zlContext.warnMsg('请保存当前新增主题成功后再操作！');
                    return;
                }
                if (layero.find('button[lay-filter="themeForm"]').hasClass('revised')) {
                    // var that = this;

                    layer.confirm('当前主题内容已被修改，是否保存？', {
                        title: false,
                        resize: false,
                        btn: ['保存', '取消'],
                        btnAlign: '',
                        anim: 1,
                        icon: 3
                    }, function (index) {
                        layero.find('button[lay-filter="themeForm"]').click();
                        addTheme(layero);
                        layer.close(index);
                    }, function () {
                        layero.find('button[lay-filter="themeForm"]').removeClass('revised');
                        addTheme(layero);
                    });
                    return;
                }
                addTheme(layero);
            })
            // 删除主题
            layero.on('click', '#delTheme', function () {
                var id = layero.find('li.layui-this').attr('data-tid');
                if (id === '25CE6A8B1C') {
                    zlContext.warnMsg('系统自带主题无法删除！')
                } else if (layero.find('li.layui-this').hasClass('newTheme')) {
                    layero.find('li.layui-this.newTheme').remove();
                    layero.find('.revised').removeClass('revised');
                    layero.find('.layui-card-theme').find('li:first-child').click();
                } else {
                    layero.find('.revised').removeClass('revised');
                    for (var i = 0; i < themes.length; i++) {
                        if (themes[i].id == id) {
                            zlTheme.temporary_theme = themes[i];
                            themes.splice(i, 1);
                            // 保存数据
                            saveTheme('delete');
                        }
                    }
                }
            })
            // 切换主题
            function switchTheme(layero, that) {
                layero.find('ul.layadmin-setTheme-color').find('li').removeClass('layui-this');
                $(that).addClass('layui-this');
                var id = $(that).attr('data-tid');
                for (var i = 0; i < themes.length; i++) {
                    if (themes[i].id == id) {
                        zlTheme.formFillData(themes[i]);
                        zlTheme.renderThemeEffect(layero, themes[i]);
                        zlTheme.ZL_theme = themes[i];
                        break;
                    }
                }

                zlTheme.renderColor(zlTheme.ZL_theme);
                zlTheme.renderStyle(zlTheme.ZL_theme);
                zlTheme.renderLayout(zlTheme.ZL_theme);

                zlTheme.renderColorPicker(layero);
                zlTheme.renderOptionsFontFamily(layero);
                // 默认主题禁止修改
                if (id === '25CE6A8B1C') {
                    layero.find('input').prop('disabled', true);
                    layero.find('select').prop('disabled', true);
                    layero.find('.showFlag').find('input').prop('disabled', false);
                    layero.find('input[type="file"]').prop('disabled', false);
                    layero.find('.operationBtn').hide();
                } else {
                    layero.find('input').prop({
                        'disabled': false,
                        'readonly': true
                    });
                    layero.find('select').prop('disabled', false);

                    layero.find('.showFlag').find('input').prop('readOnly', false);
                    layero.find('input[name="theme_title"]').prop('readOnly', false);
                    layero.find('.operationBtn').show();
                }
                // form.render(null, 'theme-form');
            }
            //点击左侧的主题列表
            layero.find('ul.layadmin-setTheme-color').on('click', 'li', function () {
                if ($(this).hasClass('layui-this')) return;
                if (layero.find('li.newTheme').length > 0) {
                    zlContext.warnMsg('请保存当前新增主题成功后再操作！');
                    return;
                }
                if (layero.find('button[lay-filter="themeForm"]').hasClass('revised')) {
                    var that = this;
                    layer.confirm('当前主题内容已被修改，是否保存？', {
                        title: false,
                        resize: false,
                        btn: ['保存', '取消'],
                        btnAlign: '',
                        anim: 1,
                        icon: 3
                    }, function (index) {
                        layero.find('button[lay-filter="themeForm"]').click();
                        switchTheme(layero, that);
                        layer.close(index);
                    }, function () {
                        switchTheme(layero, that);
                        layero.find('button[lay-filter="themeForm"]').removeClass('revised')
                    })
                    return;
                }
                switchTheme(layero, this)
            })
            // 导入json
            layero.on('click', '#importTheme', function (e) {
                var fileInput = layero.find('input[name="importThemeInput"]')[0];
                fileInput.value = ''
                if (layero.find('li.newTheme').length > 0 || layero.find('button[lay-filter="themeForm"]').hasClass('revised')) {
                    zlContext.warnMsg('请保存当前新增或修改的主题成功后再操作！');
                    return;
                }
                e.stopPropagation();
                $(this).siblings('input').click();
            })
            layero.find('input[name="importThemeInput"]').change(function () {
                if (window.File || window.FileReader || window.FileList || window.Blob) {
                    var selectedFile = this.files[0],
                        reader = new FileReader();
                    reader.readAsText(selectedFile);

                    setTimeout(function () {
                        var importThemeData = JSON.parse(reader.result);
                        var id = zlContext.generateId().toLocaleUpperCase();
                        for (var i = 0; i < themes.length; i++) {
                            if (importThemeData.theme_title == themes[i].theme_title) {
                                importThemeData.theme_title = importThemeData.theme_title + '-副本';
                                importThemeData['theme_title-py'] = zlPinYin.A(importThemeData.theme_title);
                            }
                        }

                        var importHtml = [
                            '<li data-tid="' + id + '" data-alias="' + importThemeData['theme_title-py'] + '" class="layui-this"> ',
                            '    <div class="theme-name">' + importThemeData.theme_title + '</div> ',
                            '    <div class="blank"></div> ',
                            '    <div class="layadmin-setTheme-header" style="background-color: ' + importThemeData.navBgInput + ';"></div> ',
                            '    <div class="layadmin-setTheme-side" style="background-color: ' + importThemeData.menuBgInput + ';"> ',
                            '        <div class="layadmin-setTheme-logo" style="background-color: ' + importThemeData.logoBgInput + ';"></div> ',
                            '    </div> ',
                            '</li>'
                        ];

                        layero.find('li.layui-this').removeClass('layui-this');
                        layero.find('ul.layadmin-setTheme-color').append(importHtml.join(' '))

                        layero.find('input').prop({
                            'disabled': false,
                            'readonly': true
                        });
                        layero.find('select').prop('disabled', false);

                        layero.find('.showFlag').find('input').prop('readOnly', false);
                        layero.find('input[name="theme_title"]').prop('readOnly', false);
                        layero.find('.operationBtn').show();

                        zlTheme.formFillData(importThemeData);
                        importThemeData.id = id;
                        zlTheme.temporary_theme = importThemeData;
                        zlTheme.ZL_theme = importThemeData;
                        themes = themes.concat(importThemeData)

                        zlTheme.renderColor(zlTheme.ZL_theme);
                        zlTheme.renderStyle(zlTheme.ZL_theme);
                        zlTheme.renderLayout(zlTheme.ZL_theme);

                        zlTheme.renderColorPicker(layero);
                        zlTheme.renderOptionsFontFamily(layero);
                        saveTheme('import');
                    }, 0)

                }
            })
            // 导出json
            layero.on('click', '#exportTheme', function () {
                if (layero.find('li.newTheme').length > 0 || layero.find('button[lay-filter="themeForm"]').hasClass('revised')) {
                    zlContext.warnMsg('请保存当前新增或修改的主题成功后再操作！');
                    return;
                }
                var exportThemeId = layero.find('li.layui-this').attr('data-tid'),
                    themeName = layero.find('li.layui-this').find('.theme-name').html();
                for (var i = 0; i < themes.length; i++) {
                    if (themes[i].id == exportThemeId) {
                        var blob = new Blob([JSON.stringify(themes[i])], {
                            type: ""
                        });
                        saveAs(blob, themeName + ".json");
                    }
                }
            })
            // 新增或修改主题后保存
            layero.on('click', '.operationBtn.saveData', function () {
                layero.find('button[lay-filter="themeForm"]').click();
            })
            form.on('submit(themeForm)', function (data) {
                if (!data.field.theme_title) {
                    zlContext.warnMsg('请输入主题名称!');
                    return false;
                }
                var theme_title_py = zlPinYin.A(data.field.theme_title),
                    id = layero.find('li.layui-this').attr('data-tid'),
                    flag = false,
                    index = null;
                data.field['theme_title-py'] = theme_title_py;
                data.field.id = id;
                zlTheme.ZL_theme = data.field;
                for (var i = 0; i < themes.length; i++) {
                    if (themes[i].theme_title == data.field.theme_title) {
                        flag = true;
                    }
                    if (id == themes[i].id) {
                        index = i;
                    }
                }

                if (layero.find('li.newTheme').length > 0) {
                    if (flag) {
                        zlContext.warnMsg('主题名称已存在，请更换！');
                        return false;
                    } else {
                        themes = themes.concat(data.field);
                        //保存数据
                        saveTheme('add', data.field);
                    }
                } else {
                    themes[index] = data.field;
                    //保存数据
                    saveTheme('edit', data.field);
                }

                zlTheme.temporary_theme = data.field;
                return false; //阻止表单跳转。如果需要表单跳转，去掉这段即可。
            });
            // 重置
            layero.on('click', '.operationBtn.reset', function () {
                layero.find('button[type="reset"]').click();
            })
            // 选择主题后确认
            function selectedTheme(currNodeRwid, optid) {
                var dataparams = {};
                dataparams.ORGID = currNodeRwid;
                dataparams.RWID = optid;
                dataparams.TITLE = '系统主题设置';
                dataparams.v = layero.find('li.layui-this').attr('data-tid');
                zlContext.post(layui.cache['contentPath'] + '/manager/coresysopt/modify', dataparams, function (data) {
                    if (data.state == 'OK') {
                        zlContext.successMsg('保存成功!');
                        if (theme.getTheme() == null) {
                            var userData = zlContext.getCurrentUser()
                            if (currNodeRwid == userData.currentOrgId) {
                                theme.setTheme(zlTheme.ZL_theme);
                            }
                        }
                    } else {
                        zlContext.errorMsg(data.msg);
                    }
                });
            }
            layero.on('click', '#themeConfirmBtn', function () {
                if (layero.find('li.newTheme').length > 0 || layero.find('button[lay-filter="themeForm"]').hasClass('revised')) {
                    layer.confirm('当前主题内容已被修改，是否保存后选定此主题？', {
                        title: false,
                        resize: false,
                        btn: ['保存', '取消'],
                        btnAlign: '',
                        anim: 1,
                        icon: 3
                    }, function (index) {
                        layero.find('button[lay-filter="themeForm"]').click();
                        selectedTheme(currNodeRwid, optid)
                        layer.close(index);
                    }, function () {
                        layero.find('button[lay-filter="themeForm"]').removeClass('revised')
                        selectedTheme(currNodeRwid, optid)
                    });
                    return;
                }
                selectedTheme(currNodeRwid, optid);
            })
            //保存主题
            function saveTheme(type, obj) {
                var currentLi = layero.find('li.layui-this');
                var txt = '',
                    errTxt = '',
                    url = layui.cache['contentPath'] + '/manager/coresysopt/modify';
                var dataparams = {};
                dataparams.ORGID = currNodeRwid;
                dataparams.RWID = optid;
                dataparams.TITLE = "系统主题设置--保存主题";
                dataparams.XTYPE_CV = JSON.stringify(themes);
                if (type == 'delete') {
                    txt = '删除成功';
                    errTxt = '删除失败';
                    url = layui.cache['contentPath'] + '/manager/coresysopt/removetheme';
                    var tempParams = {};
                    tempParams.entity = dataparams;
                    tempParams.id = currentLi.attr('data-tid');
                    dataparams = tempParams;
                } else if (type == 'import') {
                    txt = '导入成功';
                    errTxt = '导入失败';
                } else {
                    txt = '保存成功';
                    errTxt = '保存失败';
                }

                zlContext.post(url, dataparams, function (data) {
                    if (data.state == 'OK') {
                        zlContext.successMsg(txt);
                        if (type == 'add' || type == 'edit' || type == 'import') {
                            currentLi.attr('data-alias', zlTheme.temporary_theme['theme_title-py'])
                                .removeClass('newTheme')
                                .find('.theme-name').html(zlTheme.temporary_theme.theme_title)
                                .siblings('.layadmin-setTheme-header').css('background-color', zlTheme.temporary_theme.navBgInput)
                                .siblings('.layadmin-setTheme-side').css('background-color', zlTheme.temporary_theme.menuBgInput)
                                .find('.layadmin-setTheme-logo').css('background-color', zlTheme.temporary_theme.logoBgInput);

                            zlTheme.formFillData(zlTheme.ZL_theme);
                            zlTheme.renderThemeEffect(layero, zlTheme.ZL_theme)
                            layero.find('button[lay-filter="themeForm"]').removeClass('revised');
                        } else if (type == 'delete') {
                            currentLi.prev().click();
                            currentLi.remove();
                        }
                    } else {
                        if (type == 'add' || type == 'import') {
                            for (var i = 0; i < themes.length; i++) {
                                if (themes[i].id == zlTheme.temporary_theme.id) {
                                    themes.splice(i, 1)
                                }
                            }
                            currentLi.prev().click();
                            currentLi.remove();
                            zlContext.errorMsg(errTxt);
                        } else if (type == 'delete') {
                            themes = themes.concat(zlTheme.temporary_theme);
                            zlContext.errorMsg(data.msg);
                        }
                    }
                });
            }

            $(".layui-form-item.color").on('click', 'li', function (e) {
                var that = $(this)
                that.siblings().removeClass("theme-color-active").removeClass('fa fa-check');
                that.addClass("theme-color-active fa fa-check");
                that.parent().find('input').val(that.data('value'))
            })
            $(".layui-form-item.style").on('click', 'li', function (e) {
                var that = $(this)
                that.siblings().removeClass("theme-style-active").removeClass('fa fa-check');
                that.addClass("theme-style-active fa fa-check");
                that.parent().find('input').val(that.data('value'))
            })
            $(".layui-form-item.layout").on('click', 'li', function (e) {
                var that = $(this)
                that.siblings().removeClass("theme-layout-active").removeClass('fa fa-check');
                that.addClass("theme-layout-active fa fa-check");
                that.parent().find('input').val(that.data('value'))
            })
        },
        showform: function (themes, currNodeRwid, optid, v) {
            layer.open({
                type: 1,
                title: '系统主题选择',
                skin: 'layer-theme',
                area: ['100%', '100%'],
                id: 'theme-setter-layer',
                resize: false,
                btn: false,
                content: '<div class="themeSetter" id="theme-setter"></div>',
                success: function (layero, index) {
                    zlTheme.renderThemeList(layero, themes, v)
                    zlTheme.renderThemeBody(layero);
                    zlTheme.initEvent(layero, themes, currNodeRwid, optid);
                }
            })
        },
        color2Hex: function (color) {
            var values = color
                .replace(/rgba?\(/, '')
                .replace(/\)/, '')
                .replace(/[\s+]/g, '')
                .split(',');
            var a = parseFloat(values[3] || 1),
                r = Math.floor(a * parseInt(values[0]) + (1 - a) * 255),
                g = Math.floor(a * parseInt(values[1]) + (1 - a) * 255),
                b = Math.floor(a * parseInt(values[2]) + (1 - a) * 255);
            return "#" +
                ("0" + r.toString(16)).slice(-2) +
                ("0" + g.toString(16)).slice(-2) +
                ("0" + b.toString(16)).slice(-2);
        }

    }

    exports('zlTheme', zlTheme);
});