<#--获取某个表的所有列信息语句-->
<#-- 输入参数 -->
<#--table 表对象 属性参考CORE_TABLE -->

<#--获取表的列的信息-->
SELECT 
	A.COLUMN_NAME AS MXZD_BIANH  
	,CASE WHEN A.DATA_TYPE='INT'  THEN 'INT' 
	WHEN A.DATA_TYPE='LONGBLOB'  THEN 'BLOB' 
	WHEN (A.DATA_TYPE='FLOAT' OR  A.DATA_TYPE='REAL' OR  A.DATA_TYPE='DOUBLE' OR  A.DATA_TYPE='NUMERIC')  THEN CONCAT('DECIMAL(',CONCAT(A.NUMERIC_PRECISION),',',CONCAT(A.NUMERIC_SCALE),')')
	WHEN A.DATA_TYPE='TIME'  THEN 'TIMESTAMP' 
	ELSE UPPER(A.COLUMN_TYPE)
	END  AS MXZD_ZIDLX  
	,A.NUMERIC_SCALE  AS MXZD_XIAOSJD
	,A.COLUMN_COMMENT AS MXZD_MINGC
	,IFNULL(A.CHARACTER_MAXIMUM_LENGTH,0) MXZD_ZIDCD
	,CASE WHEN A.IS_NULLABLE='YES' THEN 1 ELSE 0 END AS MXZD_YUNXWK
	,1 AS MXZD_SHIFCJ
FROM INFORMATION_SCHEMA.COLUMNS  A  
LEFT JOIN INFORMATION_SCHEMA.KEY_COLUMN_USAGE AS P ON A.TABLE_SCHEMA = P.TABLE_SCHEMA AND A.TABLE_NAME = P.TABLE_NAME AND A.COLUMN_NAME = P.COLUMN_NAME AND P.CONSTRAINT_NAME='PRIMARY'  
WHERE A.TABLE_SCHEMA = DATABASE() AND UPPER(A.TABLE_NAME) = UPPER('${tableName}')
ORDER BY A.ORDINAL_POSITION